#ifndef _DEFS_H
#define _DEFS_H

#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <termios.h>
#include <fcntl.h>
#include <unistd.h>
#include <getopt.h>

typedef uint32_t	gbuint32;
typedef uint16_t	gbuint16;
typedef  int32_t 	 gbint32;
typedef  int16_t	 gbint16;
typedef gbuint32	gbsize_t;
typedef unsigned char	gbuint8;
typedef signed char	gbint8;


#define xmalloc malloc
#define xrealloc realloc

#define be_read32(p)       ntohl(*(uint32_t *)(p))
#define be_read16(p)       ntohs(*(uint16_t *)(p))
#define GET_BYTE(p)               (*(uint8_t *)(p))

#define be_write32(p, val)  *(uint32_t *)(p) = htonl(val)
#define be_write16(p, val)  *(uint16_t *)(p) = htons(val)
#define PUT_BYTE(p, val)          *(uint8_t  *)(p) = (val)

#endif /* _DEFS_H */
