#include "DG100Dialog.hpp"
#include "ConfigurationDialog.hpp"

#include <QSettings>

int main(int argc, char *argv[]) {
  QApplication app(argc, argv);
  app.setOrganizationName("xpg.dk");
  app.setApplicationName("qt-dg100ctl");

  QSettings settings(&app);

  QDialog *confDialog = new ConfigurationDialog();
  QMainWindow *mainWindow = new DG100Dialog(confDialog);

  /*if( !settings.contains("device") ) {

    QObject::connect( confDialog, SIGNAL(accepted()), widget, SLOT(show()));

    confDialog->show();
  } else {
    widget->show();
  }*/
  mainWindow->show();

  return app.exec();
}
